__author__ = 'Martin'

from list import List as Stack


print('\ncreate a stack')
a_stack = Stack(6)
print('stack size:', a_stack.size(), '  stack array:', a_stack.array)

print('\npush an item ||')
a_stack.push('||')
print('stack size:', a_stack.size(), '  stack array:', a_stack.array)

print('\npush 5 items')
for i in range(1, 6):
    a_stack.push(i)
print('stack size:', a_stack.size(), '  stack array:', a_stack.array)
print('full?', a_stack.is_full())
print('top:', a_stack.top())

print('\nand push another one')
try:
    a_stack.push(6)
except Exception as a:
    print('    !!!!', a, a.__class__)

print('\npop off 6')
for i in range(6):
    print(a_stack.pop(), end=', ')
print('a_stack size:', a_stack.size(), '  stack array:', a_stack.array)

print('\npop the last one:', a_stack.pop())

print('\nand pop another one')
exception = False
try:
    p = a_stack.pop()
except Exception as a:
    print('    !!!!', a, a.__class__)
    exception = True
if not exception:
    print('    no exception for underflow', 'popped item:', p)

print('\nand pop another one')
exception = False
try:
    p = a_stack.pop()
except Exception as a:
    print('    !!!!', a, a.__class__)
    exception = True
if not exception:
    print('    no exception for underflow', 'popped item:', p)

print('\nnow push 666')
a_stack.push(666)
print('stack size:', a_stack.size(), '  stack array:', a_stack.array)